Package org.springframework.web.servlet.resource

# Interface ResourceResolverChain

public interface ResourceResolverChain
A contract for invoking a chain of `ResourceResolvers` where each resolver is given a reference to the chain allowing it to delegate when necessary.

Since:
  4.1
Author:
  Jeremy Grelle, Rossen Stoyanchev, Sam Brannen

## Method Summary

Modifier and Type
Method
Description
`org.springframework.core.io.Resource`
`resolveResource(HttpServletRequest request, String requestPath, List<? extends org.springframework.core.io.Resource> locations)`
Resolve the supplied request and request path to a `Resource` that exists under one of the given resource locations.
`String`
`resolveUrlPath(String resourcePath, List<? extends org.springframework.core.io.Resource> locations)`
Resolve the externally facing public URL path for clients to use to access the resource that is located at the given internal resource path.

## Method Details

### resolveResource

@Nullable org.springframework.core.io.Resource resolveResource(@Nullable HttpServletRequest request, String requestPath, List<? extends org.springframework.core.io.Resource> locations)
Resolve the supplied request and request path to a `Resource` that exists under one of the given resource locations.

Parameters:
  `request` - the current request
  `requestPath` - the portion of the request path to use
  `locations` - the locations to search in when looking up resources
Returns:
  the resolved resource, or `null` if unresolved

### resolveUrlPath

@Nullable String resolveUrlPath(String resourcePath, List<? extends org.springframework.core.io.Resource> locations)
Resolve the externally facing public URL path for clients to use to access the resource that is located at the given internal resource path.

This is useful when rendering URL links to clients.

Parameters:
  `resourcePath` - the internal resource path
  `locations` - the locations to search in when looking up resources
Returns:
  the resolved public URL path, or `null` if unresolved